'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.spawnp = exports.execp = undefined;

var execp = exports.execp = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(command, options) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            log.trace(`execp => command: ${command} options: ${JSON.stringify(options)}`);
            return _context.abrupt('return', new Promise(function (resolve, reject) {
              var cp = (0, _child_process.exec)(command, options, function (error, stdout, stderr) {
                if (error) {
                  reject(error);
                } else {
                  resolve(stdout);
                }
              });
              cp.stdout.on('data', function (data) {
                return log.trace(data);
              });
              cp.stderr.on('data', function (data) {
                return log.debug(data);
              });
            }));

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function execp(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var spawnp = exports.spawnp = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(command, args, options) {
    var cp;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            log.trace(`spawnp => command: ${command} args: ${JSON.stringify(args)} options: ${JSON.stringify(options)}`);
            cp = (0, _child_process.spawn)(command, args, options);

            cp.stdout.on('data', function (data) {
              return log.trace(data);
            });
            cp.stderr.on('data', function (data) {
              return log.debug(data);
            });
            return _context2.abrupt('return', promisifyChildProcess(cp));

          case 5:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function spawnp(_x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

exports.promisifyChildProcess = promisifyChildProcess;

var _child_process = require('child_process');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function promisifyChildProcess(child) {
  return new Promise(function (resolve, reject) {
    child.addListener('error', function (err) {
      return reject(err);
    });
    child.addListener('exit', function (code) {
      if (code === 0) {
        resolve();
      } else {
        reject(new Error(`ChildProcess exited with code ${code}`));
      }
    });
  });
}
//# sourceMappingURL=childProcess.js.map