'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IOS_DEVICE_CONFIG = exports.ANDROID_DEVICE_CONFIG = undefined;
exports.updateDeviceConfig = updateDeviceConfig;

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ANDROID_DEVICE_CONFIG = exports.ANDROID_DEVICE_CONFIG = 'androidDeviceConfig';
var IOS_DEVICE_CONFIG = exports.IOS_DEVICE_CONFIG = 'iOSDeviceConfig';

function updateDeviceConfig(platform) {
  var usePreviousDevice = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  var key = platform === 'ios' ? IOS_DEVICE_CONFIG : ANDROID_DEVICE_CONFIG;

  var deviceConfig = _config2.default.getValue(key, {
    deviceId: ''
  });
  deviceConfig.usePreviousDevice = usePreviousDevice;
  _config2.default.setValue(key, deviceConfig);
}
//# sourceMappingURL=deviceConfig.js.map