'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.launchApplication = exports.installApplicationOnSimulator = exports.runIosApp = exports.launchSimulator = exports.askUserToSelectAniPhoneSimulator = exports.askUserToSelectAniPhoneDevice = exports.getiPhoneSimulators = undefined;

var getiPhoneSimulators = exports.getiPhoneSimulators = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var iosSims;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return simctl.getDevices();

          case 2:
            iosSims = _context.sent;
            return _context.abrupt('return', _lodash2.default.filter(_lodash2.default.flattenDeep(_lodash2.default.map(iosSims, function (val, key) {
              return val;
            })), function (device) {
              return device.name.match(/^iPhone/);
            }));

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getiPhoneSimulators() {
    return _ref.apply(this, arguments);
  };
}();

var askUserToSelectAniPhoneDevice = exports.askUserToSelectAniPhoneDevice = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(devices) {
    var choices, _ref3, selectedDevice;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            choices = _lodash2.default.map(devices, function (val, key) {
              return {
                name: `${val.name} udid: ${val.udid} version: ${val.version}`,
                value: val
              };
            });
            _context2.next = 3;
            return _inquirer2.default.prompt([{
              type: 'list',
              name: 'selectedDevice',
              message: 'Choose an iOS device',
              choices: choices
            }]);

          case 3:
            _ref3 = _context2.sent;
            selectedDevice = _ref3.selectedDevice;
            return _context2.abrupt('return', selectedDevice);

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function askUserToSelectAniPhoneDevice(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var askUserToSelectAniPhoneSimulator = exports.askUserToSelectAniPhoneSimulator = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    var iPhoneDevices, choices, emulatorConfig, simulatorUdid, previousSimulator, _ref5, selectedDevice;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getiPhoneSimulators();

          case 2:
            iPhoneDevices = _context3.sent;
            choices = _lodash2.default.map(iPhoneDevices, function (val, key) {
              return {
                name: `${val.name} (UDID ${val.udid})`,
                value: val
              };
            });

            // Check if user has set the usePreviousEmulator flag to true

            emulatorConfig = _config2.default.getValue('emulatorConfig');

            if (!(choices && emulatorConfig.ios.usePreviousEmulator)) {
              _context3.next = 11;
              break;
            }

            // Get the name of previously used simulator
            simulatorUdid = emulatorConfig.ios.simulatorUdid;
            // Check if simulator still exists

            previousSimulator = void 0;

            choices.forEach(function (val) {
              if (val && val.value.udid === simulatorUdid) {
                previousSimulator = val.value;
              }
            });

            if (!previousSimulator) {
              _context3.next = 11;
              break;
            }

            return _context3.abrupt('return', previousSimulator);

          case 11:
            _context3.next = 13;
            return _inquirer2.default.prompt([{
              type: 'list',
              name: 'selectedDevice',
              message: 'Choose an iOS simulator',
              choices
            }]);

          case 13:
            _ref5 = _context3.sent;
            selectedDevice = _ref5.selectedDevice;


            // Update the emulatorConfig
            emulatorConfig.ios.simulatorUdid = selectedDevice.udid;
            _config2.default.setValue('emulatorConfig', emulatorConfig);

            return _context3.abrupt('return', selectedDevice);

          case 18:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function askUserToSelectAniPhoneSimulator() {
    return _ref4.apply(this, arguments);
  };
}();

var launchSimulator = exports.launchSimulator = function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(deviceUdid) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt('return', new Promise(function (resolve, reject) {
              var xcrunProc = (0, _child_process.spawn)('xcrun', ['instruments', '-w', deviceUdid]);
              xcrunProc.stdout.on('data', function (data) {
                log.debug(data);
              });
              xcrunProc.stderr.on('data', function (data) {
                log.debug(data);
              });
              xcrunProc.on('close', function (code) {
                code === (0 || 255 /* 255 code because we don't provide -t option */) ? resolve() : reject(new Error(`XCode xcrun command failed with exit code ${code}`));
              });
            }));

          case 1:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function launchSimulator(_x2) {
    return _ref6.apply(this, arguments);
  };
}();

var runIosApp = exports.runIosApp = function () {
  var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref8) {
    var appPath = _ref8.appPath,
        bundleId = _ref8.bundleId;
    var iPhoneDevice;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return askUserToSelectAniPhoneSimulator();

          case 2:
            iPhoneDevice = _context5.sent;

            killAllRunningSimulators();
            _context5.next = 6;
            return (0, _spin2.default)('Waiting for device to boot', launchSimulator(iPhoneDevice.udid));

          case 6:
            _context5.next = 8;
            return (0, _spin2.default)('Installing application on simulator', installApplicationOnSimulator(iPhoneDevice.udid, appPath));

          case 8:
            _context5.next = 10;
            return (0, _spin2.default)('Launching application', launchApplication(iPhoneDevice.udid, bundleId));

          case 10:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function runIosApp(_x3) {
    return _ref7.apply(this, arguments);
  };
}();

var installApplicationOnSimulator = exports.installApplicationOnSimulator = function () {
  var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(deviceUdid, pathToAppFile) {
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            return _context6.abrupt('return', simctl.installApp(deviceUdid, pathToAppFile));

          case 1:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function installApplicationOnSimulator(_x4, _x5) {
    return _ref9.apply(this, arguments);
  };
}();

var launchApplication = exports.launchApplication = function () {
  var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(deviceUdid, bundleId) {
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            return _context7.abrupt('return', simctl.launch(deviceUdid, bundleId));

          case 1:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function launchApplication(_x6, _x7) {
    return _ref10.apply(this, arguments);
  };
}();

exports.getiPhoneRealDevices = getiPhoneRealDevices;
exports.parseIOSDevicesList = parseIOSDevicesList;
exports.killAllRunningSimulators = killAllRunningSimulators;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _child_process = require('child_process');

var _spin = require('./spin');

var _spin2 = _interopRequireDefault(_spin);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var simctl = require('node-simctl');

function getiPhoneRealDevices() {
  var devices = (0, _child_process.execSync)('xcrun instruments -s', { encoding: 'utf8' });
  var computerName = (0, _child_process.execSync)('scutil --get HostName', { encoding: 'utf8' });
  return parseIOSDevicesList(devices, computerName);
}

function parseIOSDevicesList(text, computerName) {
  var name = computerName.split('\n')[0];
  var devicePattern = /(.*?) \((.*?)\) \[(.*?)\]/;
  var noSimulatorPattern = /(.*?) \((.*?)\) \[(.*?)\] \((.*?)\)/;

  return text.split('\n').reduce(function (list, line) {
    var device = line.match(devicePattern);
    if (device && !noSimulatorPattern.test(line) && !line.includes(name)) {
      list.push({
        name: device[1],
        version: device[2],
        udid: device[3]
      });
    }

    return list;
  }, []);
}

function killAllRunningSimulators() {
  try {
    (0, _child_process.execSync)(`killall "Simulator" `);
  } catch (e) {
    // do nothing if there is no simulator launched
  }
}
//# sourceMappingURL=ios.js.map