'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mustacheRenderToOutputFileUsingTemplateFile = exports.mustacheRenderUsingTemplateFile = undefined;

// =============================================================================
// Mustache related utilities
// =============================================================================

// Mustache render using a template file
// filename: Path to the template file
// view: Mustache view to apply to the template
// returns: Rendered string output
var mustacheRenderUsingTemplateFile = exports.mustacheRenderUsingTemplateFile = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(filename, view) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', readFile(filename, 'utf8').then(function (template) {
              return _mustache2.default.render(template, view);
            }));

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function mustacheRenderUsingTemplateFile(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

// Mustache render to an output file using a template file
// templateFilename: Path to the template file
// view: Mustache view to apply to the template
// outputFile: Path to the output file


var mustacheRenderToOutputFileUsingTemplateFile = exports.mustacheRenderToOutputFileUsingTemplateFile = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(templateFilename, view, outputFile) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt('return', mustacheRenderUsingTemplateFile(templateFilename, view).then(function (output) {
              return writeFile(outputFile, output);
            }));

          case 1:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function mustacheRenderToOutputFileUsingTemplateFile(_x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

// =============================================================================
// Async wrappers
// =============================================================================

var readFile = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(filename, enc) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt('return', new Promise(function (resolve, reject) {
              _fs2.default.readFile(filename, enc, function (err, res) {
                if (err) reject(err);else resolve(res);
              });
            }));

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function readFile(_x6, _x7) {
    return _ref3.apply(this, arguments);
  };
}();

var writeFile = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(filename, data) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt('return', new Promise(function (resolve, reject) {
              _fs2.default.writeFile(filename, data, function (err, res) {
                if (err) reject(err);else resolve(res);
              });
            }));

          case 1:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function writeFile(_x8, _x9) {
    return _ref4.apply(this, arguments);
  };
}();

var _mustache = require('mustache');

var _mustache2 = _interopRequireDefault(_mustache);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
//# sourceMappingURL=mustacheUtils.js.map