'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var spinner = void 0;
var isSpinning = false;

// promisify ora spinner
// there is already a promise method on ora spinner, unfortunately it does
// not return the wrapped promise so that's a bit useless.

exports.default = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(text, prom) {
    var result;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (spinner) {
              spinner.text = text;
            } else {
              spinner = (0, _ora2.default)({
                text,
                enabled: global.ernLogLevel !== 'debug' && global.ernLogLevel !== 'trace' && !process.env.__ERN_TEST__
              });
            }

            if (!isSpinning) {
              spinner.start();
              isSpinning = true;
            }

            _context.prev = 2;
            _context.next = 5;
            return prom;

          case 5:
            result = _context.sent;

            if (isSpinning) {
              spinner.succeed();
            }
            return _context.abrupt('return', result);

          case 10:
            _context.prev = 10;
            _context.t0 = _context['catch'](2);

            if (isSpinning) {
              spinner.fail(_context.t0.message);
            }
            throw _context.t0;

          case 14:
            _context.prev = 14;

            isSpinning = false;
            return _context.finish(14);

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[2, 10, 14, 17]]);
  }));

  function spin(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return spin;
}();
//# sourceMappingURL=spin.js.map